/* Sistemas Integrados TEKNISA
   Faturamento

Nome: 6400_FAITRG_HIST_VALOR_SERVICO.SQL
0
Descrio:
Ao realizar uma alterao na tabela de servio por cliente a trigger eh
disparada para inserir os dados na tabela HISTSERVFATU.

Criao:
28/10/2003 - Rejane Priscila Leite

Manuteno:
06/11/2006 - Pedro Nerino Viol de Lima
 Convertido para Sql Server.
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'HIST_VALOR_SERVICO' and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER HIST_VALOR_SERVICO
  GO

CREATE TRIGGER HIST_VALOR_SERVICO
ON SERVCLIE
FOR INSERT, UPDATE

AS

DECLARE @V_IDCOMANDO    VARCHAR(01);
DECLARE @V_CDCLIENTE    VARCHAR(21);
DECLARE @V_CDFILIAL     VARCHAR(04);
DECLARE @V_CDSERVFILI   VARCHAR(05);

DECLARE @V_OLDCDCLIENTE VARCHAR(21);
DECLARE @V_OLDCDFILIAL  VARCHAR(04);
DECLARE @V_OLDCDSERVFIL VARCHAR(05);

DECLARE @V_DTSRVFATUHIS DATETIME;
DECLARE @V_VRSERVFATHIS FLOAT;
DECLARE @V_VRFATUDOMHIS FLOAT;
DECLARE @V_VRFATUSEGHIS FLOAT;
DECLARE @V_VRFATUTERHIS FLOAT;
DECLARE @V_VRFATUQUAHIS FLOAT;
DECLARE @V_VRFATUQUIHIS FLOAT;
DECLARE @V_VRFATUSEXHIS FLOAT;
DECLARE @V_VRFATUSABHIS FLOAT;
DECLARE @V_VRFATUFERHIS FLOAT;
DECLARE @V_VRSERVFATU   FLOAT;
DECLARE @V_DATA         DATETIME;

BEGIN

DECLARE C_DADOS CURSOR FOR

   SELECT
       'D' IDCOMANDO,
       CDCLIENTE,
       CDCLIENTE,
       CDFILIAL,
       CDFILIAL,
       CDSERVFILI,
       CDSERVFILI,
       DTSERVFATU,
       VRSERVFATU,
       VRSERVFATDOM,
       VRSERVFATSEG,
       VRSERVFATTER,
       VRSERVFATQUA,
       VRSERVFATQUI,
       VRSERVFATSEX,
       VRSERVFATSAB,
       VRSERVFATFER
     FROM
       DELETED
     WHERE
       0 = (SELECT COUNT(*) FROM INSERTED)

   UNION ALL

   SELECT
       'U' IDCOMANDO,
       INSERTED.CDCLIENTE,
       DELETED.CDCLIENTE,
       INSERTED.CDFILIAL,
       DELETED.CDFILIAL,
       INSERTED.CDSERVFILI,
       DELETED.CDSERVFILI,
       INSERTED.DTSERVFATU,
       INSERTED.VRSERVFATU,
       INSERTED.VRSERVFATDOM,
       INSERTED.VRSERVFATSEG,
       INSERTED.VRSERVFATTER,
       INSERTED.VRSERVFATQUA,
       INSERTED.VRSERVFATQUI,
       INSERTED.VRSERVFATSEX,
       INSERTED.VRSERVFATSAB,
       INSERTED.VRSERVFATFER
     FROM
       INSERTED,
       DELETED
     WHERE
       INSERTED.CDFILIAL   = DELETED.CDFILIAL      AND
       INSERTED.CDCLIENTE  = DELETED.CDCLIENTE   AND
       INSERTED.CDSERVFILI = DELETED.CDSERVFILI

   UNION ALL

   SELECT
       'I' IDCOMANDO,
       CDCLIENTE,
       CDCLIENTE,
       CDFILIAL,
       CDFILIAL,
       CDSERVFILI,
       CDSERVFILI,
       DTSERVFATU,
       VRSERVFATU,
       VRSERVFATDOM,
       VRSERVFATSEG,
       VRSERVFATTER,
       VRSERVFATQUA,
       VRSERVFATQUI,
       VRSERVFATSEX,
       VRSERVFATSAB,
       VRSERVFATFER
   FROM
     INSERTED
   WHERE
     0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_CDCLIENTE,
                                @V_OLDCDCLIENTE,
                                @V_CDFILIAL,
                                @V_OLDCDFILIAL,
                                @V_CDSERVFILI,
                                @V_OLDCDSERVFIL,
                                @V_DTSRVFATUHIS,
                                @V_VRSERVFATHIS,
                                @V_VRFATUDOMHIS,
                                @V_VRFATUSEGHIS,
                                @V_VRFATUTERHIS,
                                @V_VRFATUQUAHIS,
                                @V_VRFATUQUIHIS,
                                @V_VRFATUSEXHIS,
                                @V_VRFATUSABHIS,
                                @V_VRFATUFERHIS;

   WHILE @@FETCH_STATUS = 0 BEGIN
      IF @V_IDCOMANDO = 'I' BEGIN
         INSERT INTO HISTSERVFATU(CDCLIENTE, CDFILIAL, CDSERVFILI, DTSRVFATUHIS,VRSERVFATHIS,
                                  VRFATUDOMHIS, VRFATUSEGHIS, VRFATUTERHIS, VRFATUQUAHIS,
                                  VRFATUQUIHIS, VRFATUSEXHIS, VRFATUSABHIS, VRFATUFERHIS)
         VALUES(@V_CDCLIENTE, @V_CDFILIAL, @V_CDSERVFILI, @V_DTSRVFATUHIS,
                @V_VRSERVFATHIS, @V_VRFATUDOMHIS, @V_VRFATUSEGHIS, @V_VRFATUTERHIS,
                @V_VRFATUQUAHIS, @V_VRFATUQUIHIS, @V_VRFATUSEXHIS, @V_VRFATUSABHIS,
                @V_VRFATUFERHIS);
      END
      ELSE BEGIN
         SELECT @V_DATA = MAX(DTSRVFATUHIS)
         FROM HISTSERVFATU
         WHERE CDCLIENTE    = @V_CDCLIENTE   AND
               CDFILIAL     = @V_CDFILIAL    AND
               CDSERVFILI   = @V_CDSERVFILI  AND
               DTSRVFATUHIS = @V_DTSRVFATUHIS;

         IF (@V_DATA IS NULL) BEGIN

            INSERT INTO HISTSERVFATU(CDCLIENTE, CDFILIAL, CDSERVFILI, DTSRVFATUHIS,VRSERVFATHIS,
                                     VRFATUDOMHIS, VRFATUSEGHIS, VRFATUTERHIS, VRFATUQUAHIS,
                                     VRFATUQUIHIS, VRFATUSEXHIS, VRFATUSABHIS, VRFATUFERHIS)
            VALUES(@V_CDCLIENTE, @V_CDFILIAL, @V_CDSERVFILI, @V_DTSRVFATUHIS,
                   @V_VRSERVFATHIS, @V_VRFATUDOMHIS, @V_VRFATUSEGHIS, @V_VRFATUTERHIS,
                   @V_VRFATUQUAHIS, @V_VRFATUQUIHIS, @V_VRFATUSEXHIS, @V_VRFATUSABHIS,
                   @V_VRFATUFERHIS);
         END
         ELSE BEGIN
            UPDATE HISTSERVFATU
            SET VRSERVFATHIS = @V_VRSERVFATHIS,
                VRFATUDOMHIS = @V_VRFATUDOMHIS,
                VRFATUSEGHIS = @V_VRFATUSEGHIS,
                VRFATUTERHIS = @V_VRFATUTERHIS,
                VRFATUQUAHIS = @V_VRFATUQUAHIS,
                VRFATUQUIHIS = @V_VRFATUQUIHIS,
                VRFATUSEXHIS = @V_VRFATUSEXHIS,
                VRFATUSABHIS = @V_VRFATUSABHIS,
                VRFATUFERHIS = @V_VRFATUFERHIS
            WHERE CDCLIENTE    = @V_OLDCDCLIENTE  AND
                  CDFILIAL     = @V_OLDCDFILIAL   AND
                  CDSERVFILI   = @V_OLDCDSERVFIL  AND
                  DTSRVFATUHIS = @V_DTSRVFATUHIS;
         END;
      END;

      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_CDCLIENTE,
                                   @V_OLDCDCLIENTE,
                                   @V_CDFILIAL,
                                   @V_OLDCDFILIAL,
                                   @V_CDSERVFILI,
                                   @V_OLDCDSERVFIL,
                                   @V_DTSRVFATUHIS,
                                   @V_VRSERVFATHIS,
                                   @V_VRFATUDOMHIS,
                                   @V_VRFATUSEGHIS,
                                   @V_VRFATUTERHIS,
                                   @V_VRFATUQUAHIS,
                                   @V_VRFATUQUIHIS,
                                   @V_VRFATUSEXHIS,
                                   @V_VRFATUSABHIS,
                                   @V_VRFATUFERHIS;
   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;

-- VERSAO --
EXEC ATUVEROBJ 'HIST_VALOR_SERVICO','5.05.012';
GO

