CREATE TABLE OM_SERVICO_NOTIFICACAO (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) DEFAULT NULL NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NMSERVICONOTIF VARCHAR2(100) NOT NULL, 
  DSSERVICONOTIF VARCHAR2(100) NOT NULL,
  CONSTRAINT PK_OM_SERVICO_NOTIFICACAO PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERVICO_NOTIFICACAO ADD CONSTRAINT CKC_IDATIVO_OM_SERVICO_NOTIF CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERVICO_NOTIFICACAO START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE TABLE OM_SERVICO_NOTIF_APP_PARAM (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NMSERVNOTIFAPPPARAM VARCHAR2(100) NOT NULL, 
  DSSERVNOTIFAPPPARAM VARCHAR2(100) NOT NULL, 
  NRSERVICONOTIF_ID NUMBER(10) NOT NULL,
  CONSTRAINT PK_OM_SERVICO_NOTIF_APP_PARAM PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERVICO_NOTIF_APP_PARAM ADD CONSTRAINT OM_SERV_NOTIF_APP_SERV_NOT_FK FOREIGN KEY (NRSERVICONOTIF_ID) REFERENCES OM_SERVICO_NOTIFICACAO (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERVICO_NOTIF_APP_PARAM ADD CONSTRAINT CKC_IDATIVO_OM_SERV_NOTIF_APP CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERVICO_NOTIF_APP_PARAM START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE TABLE OM_SERVICO_NOTIF_DISP_PARAM (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NMSERVNOTIFDISPPARAM VARCHAR2(100) NOT NULL, 
  DSSERVNOTIFDISPPARAM VARCHAR2(100) NOT NULL, 
  NRSERVICONOTIF_ID NUMBER(10) NOT NULL,
  CONSTRAINT PK_OM_SERVICO_NOTIF_DISP_PARAM PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERVICO_NOTIF_DISP_PARAM ADD CONSTRAINT OM_SERV_NOT_DISP_SERV_NOT_FK FOREIGN KEY (NRSERVICONOTIF_ID) REFERENCES OM_SERVICO_NOTIFICACAO (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERVICO_NOTIF_DISP_PARAM ADD CONSTRAINT CKC_IDATIVO_OM_SERV_NOTIF_DISP CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERV_NOTIF_DISP_PARAM START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE TABLE OM_SERVICO_NOTIF_PRODUTO (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NRSERVICONOTIF_ID NUMBER(10) NOT NULL, 
  NRPRODUTO_ID NUMBER(10) NOT NULL,
  CONSTRAINT PK_OM_SERVICO_NOTIF_PRODUTO PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERVICO_NOTIF_PRODUTO ADD CONSTRAINT OM_SERV_NOT_PROD_SERV_NOT_FK FOREIGN KEY (NRSERVICONOTIF_ID) REFERENCES OM_SERVICO_NOTIFICACAO (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERVICO_NOTIF_PRODUTO ADD CONSTRAINT CKC_IDATIVO_OM_SERV_NOTIF_PROD CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERVICO_NOTIF_PRODUTO START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE TABLE OM_SERVICO_NOTIF_PRODUTO_ORG (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NRSERVICONOTIF_ID NUMBER(10) NOT NULL, 
  NRPRODUTO_ORG_ID NUMBER(10) NOT NULL,
  CONSTRAINT PK_OM_SERV_NOTIF_PRODUTO_ORG PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERVICO_NOTIF_PRODUTO_ORG ADD CONSTRAINT OM_SERV_NOT_PR_ORG_SERV_NOT_FK FOREIGN KEY (NRSERVICONOTIF_ID) REFERENCES OM_SERVICO_NOTIFICACAO (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERVICO_NOTIF_PRODUTO_ORG ADD CONSTRAINT CKC_IDATIVO_SERV_NOT_PROD_ORG CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERV_NOTIF_PRODUTO_ORG START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE TABLE OM_SERV_NOT_APP_PARAM_PROD (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NRSERVICONOTIFAPP_ID NUMBER(10) NOT NULL, 
  NRPRODUTO_ID NUMBER(10) NOT NULL, 
  DSVALORAPPPARAM VARCHAR2(100) DEFAULT NULL NULL,
  CONSTRAINT PK_OM_SERV_NOT_APP_PARAM_PROD PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERV_NOT_APP_PARAM_PROD ADD CONSTRAINT OM_SERV_N_APP_PP_SERV_N_APP_FK FOREIGN KEY (NRSERVICONOTIFAPP_ID) REFERENCES OM_SERVICO_NOTIF_APP_PARAM (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERV_NOT_APP_PARAM_PROD ADD CONSTRAINT CKC_IDATIVO_OM_SERV_NOT_APP_PP CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERV_NOT_APP_PARAM_PROD START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE TABLE OM_SERV_NOT_APP_PARAM_PROD_ORG (
  NRORG NUMBER(10) NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT NULL NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT NULL NULL, 
  NRORGULTATU NUMBER(10) DEFAULT NULL NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT NULL NULL, 
  ID NUMBER(10) NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  NRSERVICONOTIFAPP_ID NUMBER(10) NOT NULL, 
  NRPRODUTO_ORG_ID NUMBER(10) NOT NULL, 
  DSVALORAPPPARAM VARCHAR2(100) DEFAULT NULL NULL,
  CONSTRAINT PK_OM_SERV_NOT_APP_PP_ORG PRIMARY KEY(ID)
)
/
ALTER TABLE OM_SERV_NOT_APP_PARAM_PROD_ORG ADD CONSTRAINT OM_SRV_N_APP_PP_O_SRV_N_APP_FK FOREIGN KEY (NRSERVICONOTIFAPP_ID) REFERENCES OM_SERVICO_NOTIF_APP_PARAM (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERV_NOT_APP_PARAM_PROD_ORG ADD CONSTRAINT CKC_IDATIVO_OM_SRV_N_APP_PP_OR CHECK (IDATIVO IN ('S','N'))
/
CREATE SEQUENCE SEQ_OM_SERV_NOT_APP_PP_ORG START WITH 1 MINVALUE 1 INCREMENT BY 1
/
ALTER TABLE OM_PRODUTO_ORG ADD (
  DSCHAVENOTIF NUMBER(10) NULL
)
/
ALTER TABLE OM_SERV_NOT_APP_PARAM_PROD ADD CONSTRAINT OM_SERV_NOT_APP_PP_PRODUTO_FK FOREIGN KEY (NRPRODUTO_ID) REFERENCES OM_PRODUTO (ID) ON DELETE CASCADE
/
ALTER TABLE OM_SERVICO_NOTIF_PRODUTO ADD CONSTRAINT OM_SERV_NOTIF_PROD_PRODUTO_FK FOREIGN KEY (NRPRODUTO_ID) REFERENCES OM_PRODUTO (ID) ON DELETE CASCADE
/
ALTER TABLE OM_PRODUTO ADD (
  DSCHAVENOTIF VARCHAR2(100) NULL
)
/
ALTER TABLE OM_SERVICO_NOTIF_PRODUTO_ORG ADD CONSTRAINT OM_SERV_NOTIF_PROD_ORG_PROD_FK FOREIGN KEY (NRPRODUTO_ORG_ID) REFERENCES OM_PRODUTO_ORG (ID) ON DELETE CASCADE